#include "mathlib.h"
#include "quater.h"

void
main ()
{
   Quater q, q0, q1, qr, qn, qinv, qi, qj, qk, qa;
   Point px, py, pz;
   Vector axis, vx, vy, vz;;
   Matrix mr, mt, m1;
   FLOAT angle;
   
   q0.SetZero(); printf("q0 = "); q0.Display();
   q1.SetUnit(); printf("q1 = "); q1.Display();
   q.Set(1,1,1,1); printf("q = "); q.Display();
   qi.SetZero(); qi[0]=1;
   qj.SetZero(); qj[1]=1;
   qk.SetZero(); qk[2]=1;
   axis.Set(1,1,1); printf("axis = "); axis.Display();
   angle = PI/6;
   qr.SetRotation(axis,angle); printf("qr = "); qr.Display();
   px.Set(1,0,0); printf("px = "); px.Display();
   py.Set(0,1,0); printf("py = "); py.Display();
   pz.Set(0,0,1); printf("pz = "); pz.Display();
   vx.Set(1,0,0); printf("vx = "); vx.Display();
   vy.Set(0,1,0); printf("vy = "); vy.Display();
   vz.Set(0,0,1); printf("vz = "); vz.Display();
   printf("px rotated by qr = "); (qr.RotatePoint(px)).Display();
   printf("py rotated by qr = "); (qr.RotatePoint(py)).Display();
   printf("pz rotated by qr = "); (qr.RotatePoint(pz)).Display();
   printf("vx rotated by qr = "); (qr.RotateVector(vx)).Display();
   printf("vy rotated by qr = "); (qr.RotateVector(vy)).Display();
   printf("vz rotated by qr = "); (qr.RotateVector(vz)).Display();
   printf("axis rotated by qr = "); (qr.RotateVector(axis)).Display();

   mr.SetRotate(qr); printf("mr = "); mr.Display();
   mt=mr; mt.Transpose(); printf("mt = "); mt.Display();
   printf("mr*mt= "); (mr*mt).Display();
   printf("mr * px = "); (mr*px).Display();
   printf("mr * py = "); (mr*py).Display();
   printf("mr * pz = "); (mr*pz).Display();
   printf("mr * axis = "); (mr*axis).Display();

   q.Set(1,2,3,4); printf("q = "); q.Display();
   qn = q; qn.Normalize(); printf("qn = "); qn.Display();
   qinv = q.Inv(); printf("qinv = "); qinv.Display();
   printf("q.Magnitude=%6.3f\tq.Magn2=%6.3f\n",q.Magnitude(), q.Magn2());

   printf("q() = ( %6.3f, %6.3f, %6.3f, %6.3f )\n", q(0), q(1), q(2), q(3));
   printf("q[] = [ %6.3f, %6.3f, %6.3f, %6.3f ]\n", q[0], q[1], q[2], q[3]);

   printf("qi = "); qi.Display();
   printf("qj = "); qj.Display();
   printf("qk = "); qk.Display();
   printf("q + q1 = "); (q+q1).Display();
   printf("q - qi = "); (q-q1).Display();
   printf("q * qj = "); (q*q1).Display();
   printf("q / qk = "); (q/q1).Display();
   printf("q * 2 = "); (q * 2).Display();
   printf("2 * q = "); (2 * q).Display();
   printf("q / 2 = "); (q / 2).Display();
   printf("2 / q = "); (2 / q).Display();

   qa = q; printf("qa = q = "); qa.Display();
   qa = px; printf("qa = px = "); qa.Display();
   qa = axis; printf("qa = axis = "); qa.Display();

   qa = q;   printf("qa = q = "); qa.Display();
   qa += q1; printf("qa += q1 "); qa.Display();
   qa = q;   printf("qa = q = "); qa.Display();
   qa -= q1; printf("qa -= q1 "); qa.Display();
   qa = q;   printf("qa = q = "); qa.Display();
   qa *= qi; printf("qa *= qi "); qa.Display();
   qa = q;   printf("qa = q = "); qa.Display();
   qa /= qj; printf("qa /= qj "); qa.Display();
   qa = q;   printf("qa = q = "); qa.Display();
   qa *= 2;  printf("qa *= 2  "); qa.Display();
   qa = q;   printf("qa = q = "); qa.Display();
   qa /= 2;  printf("qa /= 2  "); qa.Display();
   
   if (q*qinv == q1)
   {
      printf("q1 == q*qinv = "); (q*qinv).Display();
   }
   else
   {
      printf("q1 != q*qinv = "); (q*qinv).Display();
   }  

}
